/***************************************************************
	CPUͭ쥸 إå (SH7262/7264)
***************************************************************/
#ifndef __CPU__
#define __CPU__

#include "IcqcType.h"
#include "sh7262.h"

#define	IN	0
#define	OUT	1

#define RAM_PAGE0	0x3C000000	// RAM Page0(160KB) Program
#define RAM_PAGE1	0x3C028000	//     Page1(80KB)
#define RAM_PAGE2	0x3C03C000	//     Page2(80KB)
#define RAM_PAGE3	0x3C050000	//     Page3(160KB) GRAM2
#define RAM_PAGE4	0x3C078000	//     Page4(240KB) GRAM1
#define RAM_PAGE5	0x3C0B4000	//     Page5(340KB)
#define RAM_PAGE52	0x3C0D9800	//     Page5+(320*240*2) for save image

// VIDEO_MODE
typedef struct {
	ushort			:2;
	ushort	rgb565		:1;
	ushort	inv_cbcr	:1;
	ushort			:6;
	ushort	burst_mode_disp	:1;
	ushort	burst_mode_main	:1;
	ushort			:2;
	ushort	endian_disp	:1;
	ushort	endian_main	:1;
	ushort			:1;
	ushort	sel_exsync	:1;
	ushort	sel_656601	:1;
	ushort	sel_525625	:1;
	ushort			:7;
	ushort	video_mode	:1;
	ushort			:2;
	ushort	video_disp_exe	:1;
	ushort	video_main_exe	:1;
} video_mode;

// SGMODE
typedef struct {
	ushort			:15;
	ushort	ex_sync_mode	:1;
	ushort			:15;
	ushort	rgb565		:1;
} sgmode;

// VIDEO_SAVE_NUM
typedef struct {
	ushort			:6;
	ushort	field_num	:10;
	ushort			:6;
	ushort	field_save_num	:10;
} video_save_num;

// VIDEO_INT_CNT
typedef struct {
	ushort			:3;
	ushort	int_v_en	:1;
	ushort			:3;
	ushort	int_f_en	:1;
	ushort			:3;
	ushort	int_uf_en	:1;
	ushort			:3;
	ushort	int_of_en	:1;
	ushort			:3;
	ushort	v_period	:1;
	ushort			:3;
	ushort	f_end		:1;
	ushort			:3;
	ushort	under_flow	:1;
	ushort			:3;
	ushort	over_flow	:1;
} video_int_cnt;

// GRCMEN
typedef struct {
	ushort	WE		:1;	// 쥸žĥӥåȤǤ
	ushort			:15;
	ushort			:14;
	ushort	den		:1;	// ȥ쥤ɽ(0:Ե 1:ư)
	ushort	ven             :1;	// ̥쥤ɽ    (0:Ե 1:ư)
} grcmen;

// VIDEO_SIZE
typedef struct {
	ushort			:7;
	ushort	video_height	:9;
	ushort			:6;
	ushort	video_width     :10;
} video_size;

// VIDEO_VSTART
typedef struct {
	ushort				:7;
	ushort	video_vstart_top	:9;
	ushort				:7;
	ushort	video_vstart_btm	:9;
} video_vstart;


// VIDEO_HSTART
typedef struct {
	ushort			:16;
	ushort			:7;
	ushort	video_hstart	:9;
} video_hstart;

// VIDEO_IMAGE_CNT
typedef struct {
	ushort	Contrast	:8;
	ushort	Bright		:8;
	ushort			:6;
	ushort	CLIP_Y		:1;
	ushort	CLIP_C		:1;
	ushort			:1;
	ushort	SUB_SCALE_V	:1;
	ushort	SCALE_V		:2;
	ushort			:1;
	ushort	SUB_SCALE_H	:1;
	ushort	SCALE_H		:2;
} video_image_cnt;


// VIDEO_DISP_SIZE
typedef struct {
	ushort				:7;
	ushort	video_disp_height	:9;
	ushort				:6;
	ushort	video_disp_width	:10;
} video_disp_size;

// VIDEO_VSYNC_TIM1
typedef struct {
	ushort				:6;
	ushort	video_vsync_start1_top	:10;
	ushort				:6;
	ushort	video_vsync_start1_btm	:10;
} video_vsync_tim1;

// PANEL_CLKSEL
typedef struct {
	ushort			:16;
	ushort			:2;
	ushort	icksel		:1;
	ushort	icken		:1;
	ushort			:6;
	ushort	dcdr		:6;
} panel_clksel;

// SYNCNT
typedef struct {
	ushort			:7;
	ushort	rgb_tim		:1;
	ushort			:4;
	ushort	vsync_tim	:1;
	ushort	hsync_tim	:1;
	ushort	de_tim		:1;
	ushort	m_disp_tim	:1;
	ushort			:12;
	ushort	vsync_type	:1;
	ushort	hsync_type	:1;
	ushort	de_type		:1;
	ushort	m_disp_type	:1;
} syncnt;

// GRCBUSCNT
typedef struct {
	ushort			:16;
	ushort			:7;
	ushort	burst_mode	:1;
	ushort			:3;
	ushort	bus_format	:1;
	ushort			:3;
	ushort	endian		:1;
} grcbuscnt;


// GROPEWH ΰ襵쥸
typedef struct {
	ushort			:6;
	ushort	gropsh		:10;
	ushort			:6;
	ushort	gropsw		:10;
} gropswh;

typedef struct {
	ushort			:6;
	ushort	gropdpv		:10;
	ushort			:6;
	ushort	gropdph		:10;
} gropdphv;



// GROPEWH ΰ襵쥸
typedef struct {
	ushort			:6;
	ushort	gropeh		:10;
	ushort			:6;
	ushort	gropew		:10;
} gropewh;

// GROPEDPHV ΰ賫ϰ֥쥸
typedef struct {
	ushort			:6;
	ushort	gropedpv	:10;
	ushort			:6;
	ushort	gropedph	:10;
} gropedphv;

// GROPEDPA 쥸
typedef struct {
	ushort	defa		:8;
	ushort	acoef		:8;
	ushort	arate		:8;
	ushort	WE		:1;
	ushort			:2;
	ushort	ast		:1;
	ushort			:1;
	ushort	amod		:2;
	ushort	aen		:1;
} gropedpa;

// SYN_SIZE
typedef struct {
	ushort			:6;
	ushort	syn_height	:10;
	ushort			:5;
	ushort	syn_width	:11;
} syn_size;

// PANEL_VSYNC_TIM
typedef struct {
	ushort			:6;
	ushort	vsync_start	:10;
	ushort			:6;
	ushort	vsync_end	:10;
} panel_vsync_tim;

// PANEL_HSYNC_TIM
typedef struct {
	ushort			:5;
	ushort	hsync_start	:11;
	ushort			:5;
	ushort	hsync_end	:11;
} panel_hsync_tim;

// DE_SIZE
typedef struct {
	ushort			:6;
	ushort	de_height	:10;
	ushort			:5;
	ushort	de_width	:11;
} de_size;

// DE_START
typedef struct {
	ushort			:6;
	ushort	de_start_v	:10;
	ushort			:5;
	ushort	de_start_h	:11;
} de_start;

// IPRxx
typedef struct {
	ushort	lev0	:4;
	ushort	lev1	:4;
	ushort	lev2	:4;
	ushort	lev3	:4;
} IPRxx;

// STBCR7
typedef struct {
	ushort	mstp77		:1;
	ushort	mstp76		:1;
	ushort			:1;
	ushort	mstp74		:1;
	ushort			:1;
	ushort	mstp72		:1;
	ushort			:1;
	ushort	mstp70		:1;
} stbcr7;

// STBCR4
typedef struct {
	ushort	mstp47		:1;
	ushort	mstp46		:1;
	ushort	mstp45		:1;
	ushort	mstp44		:1;
	ushort	mstp43		:1;
	ushort	mstp42		:1;
	ushort	mstp41		:1;
	ushort	mstp40		:1;
} stbcr4;

// STBCR3
typedef struct {
	ushort	hiz		:1;
	ushort	mstp36		:1;
	ushort	mstp35		:1;
	ushort	mstp34		:1;
	ushort	mstp33		:1;
	ushort	mstp32		:1;
	ushort			:1;
	ushort	mstp30		:1;
} stbcr3;

// STBCR2
typedef struct {
	ushort	mstp10		:1;
	ushort			:1;
	ushort	mstp8		:1;
	ushort	mstp7		:1;
	ushort			:4;
} stbcr2;

// PBCR5
typedef struct {
	ushort			:6;
	ushort	pb22md		:2;
	ushort			:2;
	ushort	pb21md		:2;
	ushort			:2;
	ushort	pb20md		:2;
} pbcr5;


// PFCR2
typedef struct {
	ushort			:1;
	ushort	pf11md		:3;
	ushort			:1;
	ushort	pf10md		:3;
	ushort			:1;
	ushort	pf9md		:3;
	ushort			:1;
	ushort	pf8md		:3;
} pfcr2;

// PFCR1
typedef struct {
	ushort			:1;
	ushort	pf7md		:3;
	ushort			:1;
	ushort	pf6md		:3;
	ushort			:1;
	ushort	pf5md		:3;
	ushort			:1;
	ushort	pf4md		:3;
} pfcr1;

// PFCR0
typedef struct {
	ushort			:1;
	ushort	pf3md		:3;
	ushort			:1;
	ushort	pf2md		:3;
	ushort			:1;
	ushort	pf1md		:3;
	ushort			:1;
	ushort	pf0md		:3;
} pfcr0;

// PECR0
typedef struct {
	ushort			:2;
	ushort	pe3md		:2;
	ushort			:2;
	ushort	pe2md		:2;
	ushort			:1;
	ushort	pe1md		:3;
	ushort			:2;
	ushort	pe0md		:2;
} pecr0;

// PJCR0
typedef struct {
	ushort			:2;
	ushort	pj3md		:2;
	ushort			:1;
	ushort	pj2md		:3;
	ushort			:1;
	ushort	pj1md		:3;
	ushort			:1;
	ushort	pj0md		:3;
} pjcr0;


// CMCSR
typedef struct {
	ushort			:8;
	ushort	cmf		:1;
	ushort	cmie		:1;
	ushort			:4;
	ushort	cks		:2;
} cmcsr;

// CMSTR
typedef struct {
	ushort			:14;
	ushort	str1		:1;
	ushort	str0		:1;
} cmstr;

// PCCR0
typedef struct {
	ushort			:3;
	ushort	pc3md		:1;
	ushort			:3;
	ushort	pc2md		:1;
	ushort			:3;
	ushort	pc1md		:1;
	ushort			:3;
	ushort	pc0md		:1;
} pccr0;

// PCCR1
typedef struct {
	ushort			:2;
	ushort	pc7md		:2;
	ushort			:2;
	ushort	pc6md		:2;
	ushort			:2;
	ushort	pc5md		:2;
	ushort			:2;
	ushort	pc4md		:2;
} pccr1;

// PCCR2
typedef struct {
	ushort			:7;
	ushort	pc10md0		:1;
	ushort			:3;
	ushort	pc9md0		:1;
	ushort			:2;
	ushort	pc8md		:2;
} pccr2;

// PDCR1
typedef struct {
	ushort			:2;
	ushort	pd7md		:2;
	ushort			:2;
	ushort	pd6md		:2;
	ushort			:2;
	ushort	pd5md		:2;
	ushort			:2;
	ushort	pd4md		:2;
} pdcr1;

// PCDR0
typedef struct {
	ushort			:5;
	ushort	pc10dr		:1;
	ushort	pc9dr		:1;
	ushort	pc8dr		:1;
	ushort	pc7dr		:1;
	ushort	pc6dr		:1;
	ushort	pc5dr		:1;
	ushort	pc4dr		:1;
	ushort	pc3dr		:1;
	ushort	pc2dr		:1;
	ushort	pc1dr		:1;
	ushort	pc0dr		:1;
} pcdr0;

// PDDR0
typedef struct {
	ushort	pd15dr		:1;
	ushort	pd14dr		:1;
	ushort	pd13dr		:1;
	ushort	pd12dr		:1;
	ushort	pd11dr		:1;
	ushort	pd10dr		:1;
	ushort	pd9dr		:1;
	ushort	pd8dr		:1;
	ushort	pd7dr		:1;
	ushort	pd6dr		:1;
	ushort	pd5dr		:1;
	ushort	pd4dr		:1;
	ushort	pd3dr		:1;
	ushort	pd2dr		:1;
	ushort	pd1dr		:1;
	ushort	pd0dr		:1;
} pddr0;

// PEDR0
typedef struct {
	ushort			:10;
	ushort	pe5dr		:1;
	ushort	pe4dr		:1;
	ushort	pe3dr		:1;
	ushort	pe2dr		:1;
	ushort	pe1dr		:1;
	ushort	pe0dr		:1;
} pedr0;


// PCIOR0
typedef struct {
	ushort			:5;
	ushort	pc10ior		:1;
	ushort	pc9ior		:1;
	ushort	pc8ior		:1;
	ushort	pc7ior		:1;
	ushort	pc6ior		:1;
	ushort	pc5ior		:1;
	ushort	pc4ior		:1;
	ushort	pc3ior		:1;
	ushort	pc2ior		:1;
	ushort	pc1ior		:1;
	ushort	pc0ior		:1;
} pcior0;

// PEIOR0
typedef struct {
	ushort			:10;
	ushort	pe5ior		:1;
	ushort	pe4ior		:1;
	ushort	pe3ior		:1;
	ushort	pe2ior		:1;
	ushort	pe1ior		:1;
	ushort	pe0ior		:1;
} peior0;


// PBIOR1
typedef struct {
	ushort			:9;
	ushort	pb22ior		:1;
	ushort	pb21ior		:1;
	ushort	pb20ior		:1;
	ushort	pb19ior		:1;
	ushort	pb18ior		:1;
	ushort	pb17ior		:1;
	ushort	pb16ior		:1;
} pbior1;

// PDIOR0
typedef struct {
	ushort	pd15ior		:1;
	ushort	pd14ior		:1;
	ushort	pd13ior		:1;
	ushort	pd12ior		:1;
	ushort	pd11ior		:1;
	ushort	pd10ior		:1;
	ushort	pd9ior		:1;
	ushort	pd8ior		:1;
	ushort	pd7ior		:1;
	ushort	pd6ior		:1;
	ushort	pd5ior		:1;
	ushort	pd4ior		:1;
	ushort	pd3ior		:1;
	ushort	pd2ior		:1;
	ushort	pd1ior		:1;
	ushort	pd0ior		:1;
} pdior0;


// FRQCR
typedef struct {
	ushort			:1;
	ushort	ckoen2		:1;
	ushort	ckoen		:2;
	ushort			:3;
	ushort	stc		:1;
	ushort			:2;
	ushort	ifc		:2;
	ushort			:1;
	ushort	pfc		:3;
} frqcr;

// PWCR
typedef struct {
	uchar			:2;
	uchar	ie		:1;
	uchar	cmf		:1;
	uchar	cst		:1;
	uchar	cks2		:1;
	uchar	cks1		:1;
	uchar	cks0		:1;
} pwcr;

// PWBFR
typedef struct {
	ushort			:3;
	ushort	ots		:1;
	ushort			:2;
	ushort	dt		:10;
} pwbfr;

// PWPR
typedef struct {
	ushort	ops_h		:1;
	ushort	ops_g		:1;
	ushort	ops_f		:1;
	ushort	ops_e		:1;
	ushort	ops_d		:1;
	ushort	ops_c		:1;
	ushort	ops_b		:1;
	ushort	ops_a		:1;
} pwpr;

//============================================

// PGCR0
typedef struct {
	ushort			:2;
	ushort	pg3md		:2;
	ushort			:2;
	ushort	pg2md		:2;
	ushort			:2;
	ushort	pg1md		:2;
	ushort			:4;
} pgcr0;

// PGCR1
typedef struct {
	ushort			:1;
	ushort	pg7md		:3;
	ushort			:1;
	ushort	pg6md		:3;
	ushort			:1;
	ushort	pg5md		:3;
	ushort			:1;
	ushort	pg4md		:3;
} pgcr1;

// PGCR2
typedef struct {
	ushort			:1;
	ushort	pg11md		:3;
	ushort			:1;
	ushort	pg10md		:3;
	ushort			:1;
	ushort	pg9md		:3;
	ushort			:1;
	ushort	pg8md		:3;
} pgcr2;
// PGCR3
typedef struct {
	ushort			:1;
	ushort	pg15md		:3;
	ushort			:1;
	ushort	pg14md		:3;
	ushort			:1;
	ushort	pg13md		:3;
	ushort			:1;
	ushort	pg12md		:3;
} pgcr3;
// PGCR4
typedef struct {
	ushort			:1;
	ushort	pg19md		:3;
	ushort			:1;
	ushort	pg18md		:3;
	ushort			:1;
	ushort	pg17md		:3;
	ushort			:1;
	ushort	pg16md		:3;
} pgcr4;

// PGCR7
typedef struct {
	ushort	H5A		:8;	//  H'5A
	ushort			:4;
	ushort			:1;
	ushort	pg0md		:3;
} pgcr7;

// PBDR1
typedef struct {
	ushort			:9;
	ushort	pb22dr		:1;
	ushort	pb21dr		:1;
	ushort	pb20dr		:1;
	ushort	pb19dr		:1;
	ushort	pb18dr		:1;
	ushort	pb17dr		:1;
	ushort	pb16dr		:1;
} pbdr1;

// PHCR0
typedef struct {
	ushort			:3;
	ushort	ph3md		:1;
	ushort			:3;
	ushort	ph2md		:1;
	ushort			:3;
	ushort	ph1md		:1;
	ushort			:3;
	ushort	ph0md		:1;
} phcr0;

// PFIOR0
typedef struct {
	ushort			:3;
	ushort	pf12ior		:1;
	ushort	pf11ior		:1;
	ushort	pf10ior		:1;
	ushort	pf9ior		:1;
	ushort	pf8ior		:1;
	ushort	pf7ior		:1;
	ushort	pf6ior		:1;
	ushort	pf5ior		:1;
	ushort	pf4ior		:1;
	ushort	pf3ior		:1;
	ushort	pf2ior		:1;
	ushort	pf1ior		:1;
	ushort	pf0ior		:1;
} pfior0;

// PFDR0
typedef struct {
	ushort			:3;
	ushort	pf12dr		:1;
	ushort	pf11dr		:1;
	ushort	pf10dr		:1;
	ushort	pf9dr		:1;
	ushort	pf8dr		:1;
	ushort	pf7dr		:1;
	ushort	pf6dr		:1;
	ushort	pf5dr		:1;
	ushort	pf4dr		:1;
	ushort	pf3dr		:1;
	ushort	pf2dr		:1;
	ushort	pf1dr		:1;
	ushort	pf0dr		:1;
} pfdr0;

// ADCSR
typedef struct {
	ushort	adf		:1;
	ushort	adie		:1;
	ushort	adst		:1;
	ushort	trgs		:4;
	ushort	cks		:3;
	ushort	mds		:3;
	ushort	ch		:3;
} adcsr;

// CHCR
typedef struct {
	ushort	tc		:1;
	ushort			:1;
	ushort	rldsar		:1;
	ushort	rlddar		:1;
	ushort			:1;
	ushort	daf		:1;
	ushort	saf		:1;
	ushort			:1;
	ushort	DO		:1;
	ushort	tl		:1;
	ushort			:1;
	ushort	temask		:1;
	ushort	he		:1;
	ushort	hie		:1;
	ushort	am		:1;
	ushort	al		:1;
	ushort	dm		:2;
	ushort	sm		:2;
	ushort	rs		:4;
	ushort	dl		:1;
	ushort	ds		:1;
	ushort	tb		:1;
	ushort	ts		:2;
	ushort	ie		:1;
	ushort	te		:1;
	ushort	de		:1;
} chcr;

// DMAOR
typedef struct {
	ushort			:2;
	ushort	cms		:2;
	ushort			:2;
	ushort	pr		:2;
	ushort			:5;
	ushort	ae		:1;
	ushort	nmif		:1;
	ushort	dme		:1;
} dmaor;

// SCIF
typedef struct {
	ushort			:8;
	ushort	ca		:1;
	ushort	chr		:1;
	ushort	pe		:1;
	ushort	oe		:1;
	ushort	stop		:1;
	ushort			:1;
	ushort	cks		:2;
} scsmr;

typedef struct {
	ushort			:8;
	ushort	tie		:1;
	ushort	rie		:1;
	ushort	te		:1;
	ushort	re		:1;
	ushort	reie		:1;
	ushort			:1;
	ushort	cke		:2;
} scscr;

typedef struct {
	ushort	per_cnt		:4;
	ushort	fer_cnt		:4;
	ushort	er		:1;
	ushort	tend		:1;
	ushort	tdfe		:1;
	ushort	brk		:1;
	ushort	fer		:1;
	ushort	per		:1;
	ushort	rdf		:1;
	ushort	dr		:1;
} scfsr;

typedef struct {
	ushort			:5;
	ushort	rstrg		:3;
	ushort	rtrg		:2;
	ushort	ttrg		:2;
	ushort	mce		:1;
	ushort	tfrst		:1;
	ushort	rfrst		:1;
	ushort	loop		:1;
	
} scfcr;

typedef struct {
	ushort			:3;
	ushort	t		:5;
	ushort			:3;
	ushort	r		:5;
} scfdr;

typedef struct {
	ushort			:8;
	ushort	rtsio		:1;
	ushort	rtsdt		:1;
	ushort	ctsio		:1;
	ushort	ctsdt		:1;
	ushort	sckio		:1;
	ushort	sckdt		:1;
	ushort	spb2io		:1;
	ushort	spb2dt		:1;
} scsptr;

typedef struct {
	ushort			:15;
	ushort	orer		:1;
} sclsr;

typedef struct {
	ushort			:8;
	ushort	bgdm		:1;
	ushort			:6;
	ushort	abcs		:1;
} scemr;

/****************************************************************
*	DMA
****************************************************************/

// DMA_SAR_0
extern volatile pgcr0	*pPGCR0;
extern volatile pgcr1	*pPGCR1;
extern volatile pgcr2	*pPGCR2;
extern volatile pgcr3	*pPGCR3;
extern volatile pgcr4	*pPGCR4;
extern volatile pgcr7	*pPGCR7;

extern volatile pbdr1	*pPBDR1;


extern volatile video_mode	*pVIDEO_MODE;
extern volatile sgmode		*pSGMODE;
extern volatile video_save_num	*pVIDEO_SAVE_NUM;
extern volatile video_int_cnt	*pVIDEO_INT_CNT;
extern volatile grcmen		*pGRCMEN1;
extern volatile grcmen		*pGRCMEN2;
extern volatile video_size	*pVIDEO_SIZE;
extern volatile video_vstart	*pVIDEO_VSTART;
extern volatile video_hstart	*pVIDEO_HSTART;
extern volatile video_image_cnt *pVIDEO_IMAGE_CNT;
extern volatile video_disp_size *pVIDEO_DISP_SIZE;
extern volatile panel_clksel    *pPANEL_CLKSEL;
extern volatile syncnt          *pSYNCNT;
extern volatile grcbuscnt       *pGRCBUSCNT1;
extern volatile grcbuscnt       *pGRCBUSCNT2;

extern volatile video_vsync_tim1 *pVIDEO_VSYNC_TIM1;

extern volatile syn_size        *pSYN_SIZE;
extern volatile panel_vsync_tim *pPANEL_VSYNC_TIM;
extern volatile panel_hsync_tim *pPANEL_HSYNC_TIM;
extern volatile de_size         *pDE_SIZE;
extern volatile de_start        *pDE_START;

extern volatile gropewh		*pGROPEWH1;
extern volatile gropewh		*pGROPEWH2;
extern volatile gropedphv	*pGROPEDPHV1;
extern volatile gropedphv	*pGROPEDPHV2;
extern volatile gropedpa	*pGROPEDPA1;
extern volatile gropedpa	*pGROPEDPA2;

extern volatile gropswh		*pGROPSWH1;
extern volatile gropdphv	*pGROPDPHV1;
extern volatile gropswh		*pGROPSWH2;
extern volatile gropdphv	*pGROPDPHV2;


extern volatile IPRxx	*pIPR01;
extern volatile IPRxx	*pIPR02;
extern volatile IPRxx	*pIPR05;
extern volatile IPRxx	*pIPR06;
extern volatile IPRxx	*pIPR07;
extern volatile IPRxx	*pIPR08;
extern volatile IPRxx	*pIPR09;
extern volatile IPRxx	*pIPR10;

extern volatile stbcr7  *pSTBCR7;
extern volatile pfcr2	*pPFCR2;
extern volatile pfcr1	*pPFCR1;
extern volatile pfcr0	*pPFCR0;

extern volatile pbcr5	*pPBCR5;

extern volatile cmstr	*pCMSTR;
extern volatile cmcsr	*pCMCSR_0;

extern volatile cmcsr	*pCMCSR_1;


extern volatile pccr0	*pPCCR0;
extern volatile pccr1	*pPCCR1;
extern volatile pccr2	*pPCCR2;

extern volatile pcdr0	*pPCDR0;
extern volatile pcior0	*pPCIOR0;

extern volatile pbior1	*pPBIOR1;

extern volatile frqcr	*pFRQCR;

extern volatile pdcr1	*pPDCR1;
extern volatile pddr0	*pPDDR0;
extern volatile pdior0	*pPDIOR0;


extern volatile pwcr	*pPWCR1;
extern volatile pwbfr	*pPWBFR1G;
extern volatile ushort	*pPWCYR1;

extern volatile pwpr	*pPWPR1;
extern volatile pwpr	*pPWPR2;

extern volatile phcr0	*pPHCR0;

extern volatile pecr0	*pPECR0;

extern volatile pjcr0	*pPJCR0;

extern volatile peior0	*pPEIOR0;

extern volatile pedr0	*pPEDR0;
extern volatile stbcr4	*pSTBCR4;
extern volatile stbcr3	*pSTBCR3;
extern volatile stbcr2	*pSTBCR2;

extern volatile pfior0	*pPFIOR0;
extern volatile pfdr0	*pPFDR0;
extern volatile adcsr	*pADCSR;

extern volatile dmaor	*pDMAOR;

extern volatile ulong	*pDMA_SAR_0;
extern volatile ulong	*pDAR_0;
extern volatile ulong	*pDMATCR_0;
extern volatile chcr	*pCHCR_0;
extern volatile ulong	*pRSAR_0;
extern volatile ulong	*pRDAR_0;
extern volatile ulong	*pRDMATCR_0;

extern volatile ulong	*pDMA_SAR_1;
extern volatile ulong	*pDAR_1;
extern volatile ulong	*pDMATCR_1;
extern volatile chcr	*pCHCR_1;
extern volatile ulong	*pRSAR_1;
extern volatile ulong	*pRDAR_1;
extern volatile ulong	*pRDMATCR_1;

// SCIF 0
extern volatile scsmr	*pSCSMR_0;
extern volatile uchar	*pSCBRR_0;
extern volatile scscr	*pSCSCR_0;
extern volatile uchar	*pSCFTDR_0;
extern volatile scfsr	*pSCFSR_0;
extern volatile uchar	*pSCFRDR_0;
extern volatile scfcr	*pSCFCR_0;
extern volatile scfdr	*pSCFDR_0;
extern volatile scsptr	*pSCSPTR_0;
extern volatile sclsr	*pSCLSR_0;
extern volatile scemr	*pSCEMR_0;

#define mSCSMR_0	(*pSCSMR_0)
#define mSCBRR_0	(*pSCBRR_0)
#define mSCSCR_0	(*pSCSCR_0)
#define mSCFTDR_0	(*pSCFTDR_0)
#define mSCFSR_0 	(*pSCFSR_0)
#define mSCFRDR_0	(*pSCFRDR_0)
#define mSCFCR_0 	(*pSCFCR_0)
#define mSCFDR_0 	(*pSCFDR_0)
#define mSCSPTR_0	(*pSCSPTR_0)
#define mSCLSR_0 	(*pSCLSR_0)
#define mSCEMR_0 	(*pSCEMR_0)

#define	mDMAOR		(*pDMAOR)

#define	mDMA_SAR_0	(*pDMA_SAR_0)
#define	mDAR_0		(*pDAR_0)
#define	mDMATCR_0	(*pDMATCR_0)
#define	mCHCR_0		(*pCHCR_0)
#define	mRSAR_0		(*pRSAR_0)
#define	mRDAR_0		(*pRDAR_0)
#define	mRDMATCR_0	(*pRDMATCR_0)

#define	mDMA_SAR_1	(*pDMA_SAR_1)
#define	mDAR_1		(*pDAR_1)
#define	mDMATCR_1	(*pDMATCR_1)
#define	mCHCR_1		(*pCHCR_1)
#define	mRSAR_1		(*pRSAR_1)
#define	mRDAR_1		(*pRDAR_1)
#define	mRDMATCR_1	(*pRDMATCR_1)


#define	mVIDEO_MODE	(*pVIDEO_MODE)
#define	mSGMODE		(*pSGMODE)
#define	mVIDEO_SAVE_NUM	(*pVIDEO_SAVE_NUM)
#define	mVIDEO_INT_CNT	(*pVIDEO_INT_CNT)
#define mGRCMEN1		(*pGRCMEN1)
#define mGRCMEN2		(*pGRCMEN2)
#define mVIDEO_SIZE	(*pVIDEO_SIZE)
#define mVIDEO_HSTART	(*pVIDEO_HSTART)
#define mVIDEO_VSTART	(*pVIDEO_VSTART)
#define mVIDEO_IMAGE_CNT	(*pVIDEO_IMAGE_CNT)
#define mVIDEO_DISP_SIZE	(*pVIDEO_DISP_SIZE)
#define mPANEL_CLKSEL	(*pPANEL_CLKSEL)
#define mSYNCNT		(*pSYNCNT)
#define mGRCBUSCNT1	(*pGRCBUSCNT1)
#define mGRCBUSCNT2	(*pGRCBUSCNT2)
#define mVIDEO_VSYNC_TIM1 (*pVIDEO_VSYNC_TIM1)

#define mSYN_SIZE        (*pSYN_SIZE)
#define mPANEL_VSYNC_TIM (*pPANEL_VSYNC_TIM)
#define mPANEL_HSYNC_TIM (*pPANEL_HSYNC_TIM)
#define mDE_SIZE         (*pDE_SIZE)
#define mDE_START        (*pDE_START)

#define mGROPEWH1	(*pGROPEWH1)
#define mGROPEWH2	(*pGROPEWH2)
#define mGROPEDPHV1	(*pGROPEDPHV1)
#define mGROPEDPHV2	(*pGROPEDPHV2)
#define mGROPEDPA1	(*pGROPEDPA1)
#define mGROPEDPA2	(*pGROPEDPA2)

#define mGROPSWH1	(*pGROPSWH1)
#define mGROPSWH2	(*pGROPSWH2)
#define mGROPDPHV1	(*pGROPDPHV1)
#define mGROPDPHV2	(*pGROPDPHV2)

#define mIPR01		(*pIPR01)
#define mIPR02		(*pIPR02)
#define mIPR05		(*pIPR05)
#define mIPR06		(*pIPR06)
#define mIPR07		(*pIPR07)
#define mIPR08		(*pIPR08)
#define mIPR09		(*pIPR09)
#define mIPR10		(*pIPR10)

#define mSTBCR7		(*pSTBCR7)
#define mPFCR2		(*pPFCR2)
#define mPFCR1		(*pPFCR1)
#define mPFCR0		(*pPFCR0)
#define mPBCR5		(*pPBCR5)
#define mCMSTR		(*pCMSTR)
#define mCMCSR_0	(*pCMCSR_0)
#define mCMCSR_1	(*pCMCSR_1)
#define mPCCR0		(*pPCCR0)
#define mPCCR1		(*pPCCR1)
#define mPCCR2		(*pPCCR2)
#define mPCDR0		(*pPCDR0)
#define mPCIOR0		(*pPCIOR0)
#define mPBIOR1		(*pPBIOR1)
#define	mFRQCR		(*pFRQCR)

#define mPDCR1		(*pPDCR1)

#define mPWCR1		(*pPWCR1)
#define mPWBFR1G	(*pPWBFR1G)
#define mPWCYR1		(*pPWCYR1)

#define mPDDR0		(*pPDDR0)
#define mPDIOR0		(*pPDIOR0)

#define mPWPR1		(*pPWPR1)
#define mPWPR2		(*pPWPR2)

#define mPGCR7		(*pPGCR7)
#define mPGCR4		(*pPGCR4)
#define mPGCR3		(*pPGCR3)
#define mPGCR2		(*pPGCR2)
#define mPGCR1		(*pPGCR1)
#define mPGCR0		(*pPGCR0)
#define mPBDR1		(*pPBDR1)

#define mPJCR0		(*pPJCR0)

#define mPHCR0		(*pPHCR0)
#define mPECR0		(*pPECR0)

#define mPEIOR0		(*pPEIOR0)
#define mPEDR0		(*pPEDR0)
#define mSTBCR4		(*pSTBCR4)
#define mSTBCR3		(*pSTBCR3)
#define mSTBCR2		(*pSTBCR2)

#define mPFIOR0		(*pPFIOR0)
#define mPFDR0		(*pPFDR0)
#define mADCSR		(*pADCSR)

// CMT
#define mCMCNT_0	((volatile ushort *)(0xFFFEC004))
#define mCMCOR_0	((volatile ushort *)(0xFFFEC006))

#define mCMCNT_1	((volatile ushort *)(0xFFFEC00A))
#define mCMCOR_1	((volatile ushort *)(0xFFFEC00C))

// DMA
#define xDMAOR		((volatile ulong  *)(0xFFFE1200))

// PWM
#define xPWCR1		((volatile uchar *)(0xFFFEF4E0))
#define xPWPR1		((volatile uchar *)(0xFFFEF4E4))
#define xPWBFR1G	((volatile ushort *)(0xFFFEF4EE))


// ADC
#define mADDRA	((volatile ushort *)(0xFFFF9800))
#define mADDRB	((volatile ushort *)(0xFFFF9802))
#define mADDRC	((volatile ushort *)(0xFFFF9804))
#define xADCSR	((volatile ushort *)(0xFFFF9820))

// ߥȥ쥸
#define mICR0	((volatile ushort *)(0xFFFE0800))
#define mICR1	((volatile ushort *)(0xFFFE0802))
#define mICR2	((volatile ushort *)(0xFFFE0804))
#define mIRQRR	((volatile ushort *)(0xFFFE0806))
#define mPINTER	((volatile ushort *)(0xFFFE0808))
#define mPIRR	((volatile ushort *)(0xFFFE080A))
#define mIBCR	((volatile ushort *)(0xFFFE080C))
#define mIBNR	((volatile ushort *)(0xFFFE080E))


// ӥǥǥץ쥤ȥ3쥸
#define xVIDEO_INT_CNT     ((volatile uint *)(0xFFFF2004))
#define mVIDEO_TIM_CNT      ((volatile uint *)(0xFFFF2008))

#define mVIDEO_BASEADR      ((volatile uint *)(0xFFFF2118))
#define mVIDEO_LINE_OFFSET  ((volatile uint *)(0xFFFF211C))
#define mVIDEO_FIELD_OFFSET ((volatile uint *)(0xFFFF2120))
#define mVIDEO_LINEBUFF_NUM ((volatile uint *)(0xFFFF2124))
#define mVIDEO_DISP_HSTART  ((volatile uint *)(0xFFFF212C))
#define mGRCINTCNT1         ((volatile uint *)(0xFFFF2808))
#define mGROPSADR1          ((volatile uint *)(0xFFFF2B08))
#define mGROPSOFST1         ((volatile uint *)(0xFFFF2B10))

#define mGROPCRKY0_1        ((volatile uint *)(0xFFFF2B24))
#define mGROPCRKY1_1        ((volatile uint *)(0xFFFF2B28))
#define mGROPBASERGB1       ((volatile uint *)(0xFFFF2B2C))
#define mGROPSADR2          ((volatile uint *)(0xFFFF3308))
#define mGROPSOFST2         ((volatile uint *)(0xFFFF3310))

#define mGROPCRKY0_2        ((volatile uint *)(0xFFFF3324))
#define mGROPCRKY1_2        ((volatile uint *)(0xFFFF3328))
#define mGROPBASERGB2       ((volatile uint *)(0xFFFF332C))
#define mSGINTCNT           ((volatile uint *)(0xFFFF3804))
#define mVIDEO_VSYNC_TIM2   ((volatile uint *)(0xFFFF390C))
#define mGRA_VSYNC_TIM      ((volatile uint *)(0xFFFF3910))
#define mAC_LINE_NUM        ((volatile uint *)(0xFFFF3914))


#endif

