#include <t_services.h>
#include <s_services.h>

#include "kernel_id.h"
#include "sample1.h"
#include "cpu_init.h"
#include "led.h"
#include "LCDpanel.h"
#include "graphics.h"
#include "TouchPanel.h"
#include "drive.h"

/****************************************************************
*  롼ײ
****************************************************************/
UW	task_loop;	// ǤΥ롼ײ
UW	tex_loop;	// 㳰롼ǤΥ롼ײ

int	sec=0;		// 
short	ledCnt;		// ⥳ѥ
int	doGetImage=0;	// RAM žå

// Q߰
int	cq_pos_x = -1;
int	cq_pos_y = -1;


Console	con1;		// եå1
Console	con2;		// 󥽡


static	void init(void);
int	getPositionx(int *px,int *py);	// Ѱָ
void	movex(int vect);
int	getDirx(int vect,int *px,int *py);
int	turnx(int vect);

/****************************************************************
*  ᥤ󥿥
****************************************************************/
void main_task(VP_INT exinf)
{
	int	tx,ty;

	init();

	vmsk_log(LOG_UPTO(LOG_INFO), LOG_UPTO(LOG_EMERG));
	syslog(LOG_NOTICE, "Sample program starts (exinf = %d).", (INT) exinf);

	syscall(serial_ctl_por(TASK_PORTID,
			(IOCTL_CRLF | IOCTL_FCSND | IOCTL_FCRCV)));

	/****************************************************************
 	*  εư
	****************************************************************/
	sta_cyc(CYCHDR1);

	ledCnt = 0;	// Remote control stop

	tx=ty=-1;
	for(;;)
	{
		if(TOUCH_stat > 10)
		{
			dispStr(&con2,0,0," Intelligent ChQ Ctr");
		
			TOUCH_xy();
			dispNum(&con2, 7,1,TOUCH_X  ,4,10);
			dispNum(&con2,13,1,TOUCH_Y  ,4,10);

			CON_mark(&con2,MARK_SQR,tx,ty,0);		// õ
			CON_mark(&con2,MARK_PLUS,TOUCH_X,TOUCH_Y,0xf800);// +ɽ
			tx = TOUCH_X;
			ty = TOUCH_Y;
			TOUCH_stat = 0;

			act_tsk(TASK_CQ);
			syslog(LOG_NOTICE, "==========================");
			syslog(LOG_NOTICE, "task sleep main.");
			slp_tsk();
			syslog(LOG_NOTICE, "task wup   main.\r\n---");
		}
		// å֤򸡽ФѤΰָФԤ
		// ѸХ˰ܹԤ뤫
	}

	syslog(LOG_NOTICE, "Sample program ends.");
	kernel_exit();
}
/****************************************************************
*  楿
****************************************************************/
void taskCq(VP_INT exinf)
{
	int	goalStep;

	ena_tex();	// 㳰ε

	syslog(LOG_NOTICE, "----taskCq----");

	dispStr(&con2,8,2,"------");

	goalStep = 0;

	while(toGoal(&goalStep) != 0)
	{
	}

	dispStr(&con2,8,2,"-Goal-");
	syslog(LOG_NOTICE, "----Goal----");

	wup_tsk(MAIN_TASK);
	ext_tsk();
}
/****************************************************************
*	
****************************************************************/
static void init(void)
{
	int	i;

	define_int_plevel (IPR10, 15, 0);	// CMT1 
	define_int_plevel (IPR10,  3, 8);	// VDC3 

	CPU_BusInitialize();
	PWMInitialize();
	DMAInitialize();

	LCDpanel_Initialize();	// LCDѥͥ
	TOUCH_Initialize();

	initConsole(&con1,GRA1_HORIZONTAL_SIZE,
		GRA1_VERTICAL_SIZE,(ushort *)GRA1_VRAM_BASE);

	initConsole(&con2,GRA2_HORIZONTAL_SIZE,
		GRA2_VERTICAL_SIZE,(ushort *)GRA2_VRAM_BASE);

	makeGrCntTbl();		// 졼Ѵơ֥

	Con_fill(&con1,0x0000);
	Con_fill(&con2,0x0000);

	CMT_1_Initialize();

	dispStr(&con2,0,0," Intelligent ChQ Ctr");

	mVIDEO_MODE.video_main_exe = 1;
	mVIDEO_INT_CNT.int_f_en    = 1;	// 

	// ޥǡäƤ
	for(i=0;i<16;i++)
		ledPtnSet(RM_BAND,i,&ledPtnList[i]);

}
/****************************************************************
 *  ϥɥ
 *  åָ
****************************************************************/
void cyclic_handler(VP_INT exinf)
{
	TOUCH_sta();	// åָ
}
/****************************************************************
*  ¹ԤƼ¹Ԥ륿ѤΥ㳰롼
****************************************************************/
void tex_routine(TEXPTN texptn, VP_INT exinf)
{
	volatile UW	i;
	INT	tskno = (INT) exinf;

	syslog(LOG_NOTICE, "task%d receives exception 0x%04x. ",
					tskno, texptn);
	for (i = 0; i < tex_loop; i++);

	if (texptn & 0x8000) {
		syslog(LOG_INFO, "#%d#ext_tsk()", tskno);
		ext_tsk();
	}
}
/****************************************************************
*  CPU㳰ϥɥ
****************************************************************/
#ifdef CPUEXC1

void
cpuexc_handler(VP p_excinf)
{
	ID	tskid;

	syslog(LOG_NOTICE, "CPU exception handler (p_excinf = %08p).",
							p_excinf);
	if (sns_ctx() != TRUE) {
		syslog(LOG_WARNING,
			"sns_ctx() is not TRUE in CPU exception handler.");
	}
	if (sns_dpn() != TRUE) {
		syslog(LOG_WARNING,
			"sns_dpn() is not TRUE in CPU exception handler.");
	}
	syslog(LOG_DEBUG,
		"sns_loc = %d sns_dsp = %d", sns_loc(), sns_dsp());
	syslog(LOG_DEBUG,
		"vxsns_loc = %d vxsns_ctx = %d vxsns_dsp = %d vxsns_dpn = %d",
		vxsns_loc(p_excinf), vxsns_ctx(p_excinf),
		vxsns_dsp(p_excinf), vxsns_dpn(p_excinf));

	if (!vxsns_loc(p_excinf) && !vxsns_ctx(p_excinf)) {
		syscall(iget_tid(&tskid));
		syscall(iras_tex(tskid, 0x8000));
	}
	else {
		syslog(LOG_NOTICE, "Sample program ends with exception.");
		kernel_exit();
	}
}

#endif /* CPUEXC1 */
